R-API code
==========

A Design Decision of R-API is that everything pipe into the next thing set and reasonable input.

A Design Decision of R-API is that everything expect to receive a set and input.

---

The primary use case of R-API is a SENSIBLE DEFAULT MODEL for ONE COMMAND MODEL for REACT API ROUTES.

The LIBRARY is definitions of available routes and their attachment on the web server. A Web Application accepts web traffic from the internet.

The primary means of R-API is .


```javascript



```

---

### Map

Right now I can define routes like

```js
/**
	The Model Routes
**/

xRouter.get('/', async (req, res) => {
    if (parseInt(req.query.errorCode) === 2) {
        res.locals.flash = app.Flash({
            category: 'warning',
            message: `Requested resource is not found.`
        });
    }

    const page = { title: 'Experiences' };
    const experiences = await IP.findAll({ raw: true });
    res.render('x/list', { experiences, page });
});

const handleNotFound = (req, res) => {
    res.redirect('/x?errorCode=2');
};

const handleAccessDenied = (req, res) => {
    const { slug } = req.params;
    res.redirect(`/x/${slug}?errorCode=1`);
};

module.exports = xRouter;

/**
	The Server
**/
const app = express();
const http = require('http').Server(app);
app.use(express.json());
app.use('/', pagesRouter);
app.use('/api', apiRouter);
app.use('/x', xRouter);
http.listen(port, function() {
  console.log(`listening on port ${port}`);
});
```

#### Destination 1: 

* GET specified resource
* GET collection of resource
* POST resource
* POST collection of resource
* PATCH resource
* PATCH collection of resource
* DELETE a specified resource
* DELETE a collection of resource
* Same-origin only
* JSON-format only
* Self-description


#### Destination 2: Non-Standard Routes

Maybe a given resource needs non-standard routes like this
```js

xRouter.get('/:slug/enjoy', async (req, res) => {
    const { slug } = req.params;
    const experience = await IP.findOne({ where: { slug }, raw: true });
    if (!experience) {
        res.appContext.notFound = slug;
        handleNotFound(req, res);
        return;
    }

    const access = await app.checkIPAccess({ person: res.appContext.currentUser, ip: experience });
    if (!access) {
        res.appContext.accessDenied = { user: res.appContext.currentUser, ip: experience };
        handleAccessDenied(req, res);
        return; 
    }

    const page = { title: `Experience ${experience.name}` };
    res.render('x/enjoy', { page, x: experience });
});
````

#### Destination Forgiveness:

Add Support for HTML MIMETYPE. Requests support `.html` and ?format=html to return HTML rather than JSON